алексей556

значения переменных в макросе из 3d модели

Подскажите как получить в макросе значения переменных, описанных в SW property tab builder для 3д модели?

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах


Не ясен вопрос.

Вот кусочек содержимого файла таббилдера:     

<Control Label="Разработал" PropName="Разраб." ApplyTo="Global" Type="ComboBox" UserDefineable="True">
        <Data Range="A1:A100" SheetIndex="1" Path="D:\Шаблоны SolidWorks 2016\Свойства пользователя\Поле разработал.xls" SourceType="Excel" />
      </Control>

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах

Подскажите как получить в макросе значения переменных, из 3д модели? Задача сделать макрос сохранения файла с номером версии. т.е. в макросе надо получить значение переменной Revision

Screenshot_1.png

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах

Задача сделать макрос сохранения файла с номером версии. т.е. в макросе надо получить значение переменной Revision

Screenshot_1.png

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах

А где в ТабБильдере эта переменная "Ревизия"?

В скрине Вы приводите набор переменных чертежа, а в первом сообщении речь шла о 3Д модели.

В торговле, я помню, был такой термин "Ревизия". А в ЕСКД кроме "Номер изменения" мне ничего не приходит в голову. Попробую проанализировать эту "Ревизию" в своих файлах - чем же она интересна?

Если говорить о "Номере изменения", но у меня в каждой 3Д модели есть такая переменная (и номер извещения тоже) и я ее использую где хочу - в том числе добавляю в конец имени файла при сохранении. Но заполняю в 3Д модели  вручную.

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах
23 минуты назад, VOleg сказал:

А где в ТабБильдере эта переменная "Ревизия"?

В скрине Вы приводите набор переменных чертежа, а в первом сообщении речь шла о 3Д модели.

В торговле, я помню, был такой термин "Ревизия". А в ЕСКД кроме "Номер изменения" мне ничего не приходит в голову. Попробую проанализировать эту "Ревизию" в своих файлах - чем же она интересна?

Если говорить о "Номере изменения", но у меня в каждой 3Д модели есть такая переменная (и номер извещения тоже) и я ее использую где хочу - в том числе добавляю в конец имени файла при сохранении. Но заполняю в 3Д модели  вручную.

просто так назвали переменную. это номер версии, которую заполняю в 3д модели вручную. вопрос как ее вытащить в макрос и использовать для добавления к имени файла.

макрос по кнопочке делает dwg в нужную папку см.вложение

Screenshot_2.png

 

Macro_dwg.zip

Изменено пользователем алексей556
изменил

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах

Если есть переменная, то в макросе ее легко получить - мне программисты вставляли все, что я хотел. Сам-то я в это не лезу.

Однако, я стараюсь иностранными словами не пользоваться.

Вот какой перевод дал интернет слова "Revision"

А Вы говорите, что у Вас это "версия".

А вот что означает "версия" в SWE PDM? Но это у них не "изменение".

 

Версия.PNG

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах

VOleg, так все же каким оператором (кодом) можно получить значение в макросе из атрибута свойства пользователя. Подскажите, или пришлите образец макроса где вы добавляете "номер извещения в конец имени файла"

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах

- Подскажите, а каким образом из сотен деталей и сборок на чертеже надо выбрать нужную (деталь), чтоб потом макросом обработать?

- Подскажите, а куда будет вноситься информация о "номере версии"?

- Подскажите, а что будет если "переменной" "Revision" не окажется в файле?

- Подскажите, а "задачу сделать макрос" вы кому ставите? )))

 

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах
22 часа назад, алексей556 сказал:

Задача сделать макрос сохранения файла с номером версии. т.е. в макросе надо получить значение переменной Revision

Вот как раз под рукой оказалось:

Цитата

Dim swApp As Object

Dim ModelDoc As ModelDoc2

Set swApp = Application.SldWorks

Set ModelDoc = swApp.ActiveDoc

MsgBox ModelDoc.Extension.CustomPropertyManager("").Get("Revision")

InputBox
Debug.Print ModelDoc.Extension.CustomPropertyManager("").Set("Revision", InputBox( "введите новое значение или Inbox замените переменной с нужной цифрой"))

Если данного свойства нет, то надо его добавить:  ModelDoc.Extension.CustomPropertyManager("").Add...

Или во все шаблоны добавить, что бы нужное свойство было во всех шаблонах. Но если данного свойства нет, то оно не скорректируется и не покажется.

Изменено пользователем Kelny
1 пользователю понравилось это

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах
21 час назад, Kelny сказал:

Вот как раз под рукой оказалось:

Если данного свойства нет, то надо его добавить:  ModelDoc.Extension.CustomPropertyManager("").Add...

Или во все шаблоны добавить, что бы нужное свойство было во всех шаблонах. Но если данного свойства нет, то оно не скорректируется и не покажется.

Спасибо, работает, могу получить свойства с чертежа, но там нет требуемого (Revision), оно прописано в 3д модели в конкретной конфигурации (см.изображение). Макрос вызывается с чертежа (для автом. сохранения в dwg). Вопрос как его получить в свойствах на чертеже (см. изображение)? или как его добавить/прописать в макросе если можно поподробней.Screenshot_3.png.d1fc47e48847a62b6640dc30ba915fbd.pngScreenshot_4.png.9f68f9ef073e91fa10154d890d825d0c.png

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах

 

1 час назад, алексей556 сказал:

нет требуемого (Revision), оно прописано в 3д модели в конкретной конфигурации (см.изображение). Макрос вызывается с чертежа (для автом. сохранения в dwg). Вопрос как его получить в свойствах на чертеже (см. изображение)? или как его добавить/прописать в макросе если можно поподробней.

Не нужен для этого макрос, надо просто в заметке листа или свойстве чертежа добавить ссылку: $PRPSHEET:"Revision"

Если свойство с таким именем (в вашем случае Revision) будет в закладке КОНФИГУРАЦИИ и в закладке НАСТРОЙКИ, то будет взято значение из закладки НАСТРОЙКИ.

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах
27 минут назад, Kelny сказал:

 

Не нужен для этого макрос, надо просто в заметке листа или свойстве чертежа добавить ссылку: $PRPSHEET:"Revision"

Если свойство с таким именем (в вашем случае Revision) будет в закладке КОНФИГУРАЦИИ и в закладке НАСТРОЙКИ, то будет взято значение из закладки НАСТРОЙКИ.

Не работает: если ставлю тип "текст", то вычисленное значение остается $PRPSHEET:"Revision", если ставлю тип "номер", то пишет недопустимое значение. А на чертеже значение определяет. что не так?Screenshot_5.thumb.png.db17355ad3dca7b1221b0ed75f4d9c61.png

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах
22 минуты назад, алексей556 сказал:

Не работает: если ставлю тип "текст", то вычисленное значение остается $PRPSHEET:"Revision"

Так и должно быть. После этого на чертеже вместо ссылки $PRPSHEET:"Revision" уже ссылка на свойства файла $PRP:"Revision" и в заметке будет ваша ревизия.

 

23 минуты назад, алексей556 сказал:

А на чертеже значение определяет. что не так?

Всё так, просто окно свойств не обсчитывает такие ссылки (это уже вопрос  к разработчикам, почему эти ссылки не выдают значение в графу вычисленного значения), но после добавления в заметку данного свойства всё пересчитается в значение по ссылке.

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах
55 минут назад, Kelny сказал:

Так и должно быть.

в макросе в результате считывает значение как текст "$PRPSHEET:"Revision", а не требуемое число.

Screenshot_6.png.5c595e11230275ea94852bccaf5e2761.png

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах
2 часа назад, алексей556 сказал:

в макросе в результате считывает значение как текст "$PRPSHEET:"Revision", а не требуемое число.

Читайте заметку со ссылкой, получите требуемое число.

В ранних версиях другого способа не нашёл поэтому вставлял заметку с требуемой ссылкой, считывал значение и удалял заметку (может в новых версиях по другому или в старых версиях не доглядел чего):

Set swNote = ModelDoc2.InsertNote("$PRPSHEET:" & Chr(34) & "Revision")
swNote.SetName ("Temp_Note")
MsgBox  swNote.GetText
ModelDoc2.Extension.SelectByID2 "Temp_Note@" & swDraw.GetSheetNames(0), "NOTE", 0, 0, 0, False, 0, Nothing, 0
ModelDoc2.EditDelete

 

Изменено пользователем Kelny

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах
В ‎18‎.‎10‎.‎2017 в 14:10, алексей556 сказал:

номер версии, которую заполняю в 3д модели вручную. вопрос как ее вытащить в макрос и использовать для добавления к имени файла.

Можно так:

Скрытый текст

Sub main()

Dim swApp As SldWorks.SldWorks
Dim Part As SldWorks.ModelDoc2
    
    Dim swDraw                      As SldWorks.DrawingDoc
    Dim swView                      As SldWorks.View
    Dim swCustProp                  As CustomPropertyManager
    Dim Rev                         As String

Dim FilePath As String
Dim PathSize As Long
Dim PathNoExtension As String
Dim NewFilePath As String
Dim sPath As String
Dim sName As String



Set swApp = Application.SldWorks
Set Part = swApp.ActiveDoc

If Part.GetType = swDocASSEMBLY Or Part.GetType = swDocPART Then
    MsgBox "Откройте чертёж."
    Exit Sub
End If
        
Dim swModel                     As SldWorks.ModelDoc2
    
    Set swDraw = swApp.ActiveDoc
    Set swView = swDraw.GetFirstView
    Set swView = swView.GetNextView
    Set swModel = swView.ReferencedDocument
    
    Set swCustProp = swModel.Extension.CustomPropertyManager("")
        swCustProp.Get2 "Revision", 30, Rev
    Set swCustProp = Part.Extension.CustomPropertyManager("")
        swCustProp.Add2 "Revision", 30, Rev
   

FilePath = Part.GetPathName

    i = Len(FilePath)
    Do While Mid(FilePath, i, 1) <> "\"
      i = i - 1
    Loop
    sPath = Left(FilePath, i) 'путь без имени файла
    sName = Mid(FilePath, i + 1) 'имя файла
    sNameNoExtension = Left(sName, Len(sName) - 7) 'имя файла без расширения (обрезали .slddrw)

PathSize = Strings.Len(FilePath)

NewFilePath_dwg = "d:\" & sNameNoExtension & " - Версия " & Rev & ".dwg"

Part.SaveAs2 NewFilePath_dwg, 0, True, False

MsgBox "Готово"

End Sub

 

 

Изменено пользователем Kir95

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах
В 20.10.2017 в 19:55, Kir95 сказал:

Set swCustProp = swModel.Extension.CustomPropertyManager("") swCustProp.Get2 "Revision", 30, Rev Set swCustProp = Part.Extension.CustomPropertyManager("") swCustProp.Add2 "Revision", 30, Rev

не берет значение из переменной Revision (см. скрин)Screenshot_7.png.60455de17ab2790a92b59d95061ed4dd.png

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах
7 часов назад, алексей556 сказал:

не берет значение из переменной Revision (см. скрин)

Напишите MsgBox "Версия-" + Rev, получите окно с номером версии из модели, но если всё-таки:

 

В ‎18‎.‎10‎.‎2017 в 12:56, алексей556 сказал:

Задача сделать макрос сохранения файла с номером версии.

то достаточно создать новый макрос и вставить в него код из предыдущего поста (перед вставкой очистите содержимое, которое создаётся автоматически). Получите двг файл с номером версии (Revision).

Солид какого года у вас?

версия -1.JPG

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах
В 23.10.2017 в 21:36, Kir95 сказал:

Напишите MsgBox "Версия-" + Rev

результат тот же - пустое значение. sw2012. код взят из предыдущего поста, как было написано. Почему то не хочет вычислять значение из переменной revision (ни в свойствах, ни в макросе):Screenshot_8.thumb.png.2c5705b9ecf810e3362c7e9659b08bae.png

Screenshot_9.png.0dbb087f0d4d84a315c76f2e7d6b51ca.png

 

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах
33 минуты назад, алексей556 сказал:

результат тот же - пустое значение. sw2012. код взят из предыдущего поста, как было написано. Почему то не хочет вычислять значение из переменной revision (ни в свойствах, ни в макросе):

Может во втором виде у вас другая модель (без ревизии) или второй вид пустой (без моделей)?

Ведь предложенный макрос выбирает первый вид, а потом выбирает второй:

    Set swView = swDraw.GetFirstView
    Set swView = swView.GetNextView

Может вторую строчку исключить и остановиться только:

    Set swView = swDraw.GetFirstView

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах
В 20.10.2017 в 15:22, Kelny сказал:

Читайте заметку со ссылкой, получите требуемое число.

сначала была ошибка что swNote не определено, добавил так: Dim swNote As SldWorks.ModelDoc2 

потом ошибка: run-time error 424 Object required на строке Set swNote = ModelDoc2.InsertNote("$PRPSHEET:" & Chr(34) & "Revision")

у меня sw2012.

20 минут назад, Kelny сказал:

Может вторую строчку исключить

если исключить - ошибка

Screenshot_10.png.2e0724d81c871d84d8e8877d35984d68.png

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах
40 минут назад, алексей556 сказал:

если исключить - ошибка

Может активирован режим:

' Включаем проверку переменных VBA
Option Explicit

и требуется объявить swCustProp или убрать проверку.

 

42 минуты назад, алексей556 сказал:

сначала была ошибка что swNote не определено, добавил так: Dim swNote As SldWorks.ModelDoc2 

потом ошибка: run-time error 424 Object required на строке Set swNote = ModelDoc2.InsertNote("$PRPSHEET:" & Chr(34) & "Revision")

у меня sw2012.

Вы чего-то всё мешаете в одну кучу, я приводил свой метод считывания значения с заметки. Данный метод сработал?

 

Потом вам предложили другой метод, когда не надо создавать заметку, а можно читать данные прямо из модели на которую ссылается второй вид в чертеже.

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах
2 часа назад, Kelny сказал:

Вы чего-то всё мешаете в одну кучу

это два разных теста/макроса (пробую и так и так) - пока оба не работают.

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах
3 часа назад, Kelny сказал:

Может вторую строчку исключить и остановиться только:

FirstView у солида - это лист. Исключив вторую строчку вы будете брать значения с null вида.

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах
В 19.10.2017 в 08:06, streamdown сказал:

- Подскажите, а каким образом из сотен деталей и сборок на чертеже надо выбрать нужную (деталь), чтоб потом макросом обработать?

- Подскажите, а куда будет вноситься информация о "номере версии"?

- Подскажите, а что будет если "переменной" "Revision" не окажется в файле?

- Подскажите, а "задачу сделать макрос" вы кому ставите? )))

1) текущий чертеж детали/сборки
2) в имя файла.
3) ничего
4) себе.

Еще вопросы будут или предложите решение?

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах
30 минут назад, алексей556 сказал:

Еще вопросы будут

На, выполняй поставленную себе задачу по написанию тебе макроса))

(основа с поста выше)

Скрытый текст

 

Sub main()

Dim swApp As SldWorks.SldWorks
Dim Part As SldWorks.ModelDoc2
    
    Dim swDraw                      As SldWorks.DrawingDoc
    Dim swView                      As SldWorks.View
    Dim swCustProp                  As CustomPropertyManager
    Dim Rev                         As String
    Dim confName As String
    

Dim FilePath As String
Dim PathSize As Long
Dim PathNoExtension As String
Dim NewFilePath As String
Dim sPath As String
Dim sName As String

Set swApp = Application.SldWorks
Set Part = swApp.ActiveDoc

If Part.GetType = swDocASSEMBLY Or Part.GetType = swDocPART Then
    MsgBox "Откройте чертёж."
    Exit Sub
End If
        
Dim swModel                     As SldWorks.ModelDoc2
    
    Set swDraw = swApp.ActiveDoc
    Set swView = swDraw.GetFirstView
    Set swView = swView.GetNextView
    Set swModel = swView.ReferencedDocument
    confName = swView.ReferencedConfiguration
    Set swCustProp = swModel.Extension.CustomPropertyManager(confName)
        swCustProp.Get2 "Revision", 30, Rev
    'Set swCustProp = Part.Extension.CustomPropertyManager("")
     '   swCustProp.Add2 "Revision", 30, Rev
   

FilePath = Part.GetPathName

    i = Len(FilePath)
    Do While Mid(FilePath, i, 1) <> "\"
      i = i - 1
    Loop
    sPath = Left(FilePath, i) 'путь без имени файла
    sName = Mid(FilePath, i + 1) 'имя файла
    sNameNoExtension = Left(sName, Len(sName) - 7) 'имя файла без расширения (обрезали .slddrw)

'PathSize = Strings.Len(FilePath)

If Trim(Rev & vbNullString) = vbNullString Then
    MsgBox "Нет версии! Сохранение не произойдёт"
    Exit Sub
End If

NewFilePath_dwg = sPath & sName & " - Версия " & Rev & ".slddrw"

Part.SaveAs2 NewFilePath_dwg, 0, True, False

MsgBox "Готово"

End Sub

 

 

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах
59 минут назад, streamdown сказал:

confName = swView.ReferencedConfiguration
    Set swCustProp = swModel.Extension.CustomPropertyManager(confName)

Спасибо за уточнение, теперь работает! По моему вопросу я ожидал более скромный ответ, а не целиком код :) Что то типа:

Dim swCustProp As CustomPropertyManager

Dim Rev As String

    Set swApp = Application.SldWorks
    Set Part = swApp.ActiveDoc

    Set swDraw = swApp.ActiveDoc
    Set swView = swDraw.GetFirstView
    Set swView = swView.GetNextView
    Set swModel = swView.ReferencedDocument
    confName = swView.ReferencedConfiguration
    Set swCustProp = swModel.Extension.CustomPropertyManager(confName)
        swCustProp.Get2 "Revision", 30, Rev  ' значение переменной Revision, описанной в 3д модели

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах

Опять не так ответил... да что ж я такой невнимательный :wallbash: :biggrin:

3 пользователям понравилось это

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах

А вообще зачем нужно видеть ревизию в имени файла? я и так вижу и сортирую по "ревижен" файлы и ищу и выборку делаю..

Да... тотал :bleh:

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах
В 04.11.2017 в 19:25, Maik812 сказал:

А вообще зачем нужно видеть ревизию в имени файла?

Затем, что некоторые отечественные системы менеджмента файлов. при открытии одноименных файлов от разных "версий" объектов, пишут "файл с таким именем уже открыт. перечитать?" и закрывают файл.

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах
13 часа назад, xxxx сказал:

Затем, что некоторые отечественные системы менеджмента файлов. 

Попробуйте менеджер файлов , с большими возможностями. можно пообщатся по тому что нужно конкретно. Я не знаю что Вы юзаете попробуйте

 

Revision  показывает и сортирует, также вводится в фаил . но все до 2015 версии Солида. Не кто не хочет плагин написать с АПИ.

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах
10 часов назад, Maik812 сказал:

Не кто не хочет плагин написать с АПИ.

За то время что вы рассказываете что вам ни кто ни чего не пишет уже бы сами ни один раз освоили и писали бы в своё удовольствие всё что вам хочется...

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах

@Maik812

"менеджер файлов" -"Лоцман", причем не последней версии

Поделиться сообщением


Ссылка на сообщение
Поделиться на других сайтах

Создайте аккаунт или войдите для комментирования

Вы должны быть пользователем, чтобы оставить комментарий

Создать аккаунт

Зарегистрируйтесь для получения аккаунта. Это просто!


Зарегистрировать аккаунт

Войти

Уже зарегистрированы? Войдите здесь.


Войти сейчас

  • Сейчас на странице   0 пользователей

    Нет пользователей, просматривающих эту страницу

  • реклама

  • Реклама

  • Ближайшие события

    Предстоящих событий не найдено
  • Дни рождения сегодня

    1. Anki
      Anki
      (38 лет)
    2. aqwa
      aqwa
      (46 лет)
    3. biser.73
      biser.73
      (44 года)
    4. C-Cam
      C-Cam
      (32 года)
    5. helicopt
      helicopt
      (41 год)
    Просмотреть все